/*
Copyright (C) 2013 NTT DATA Corporation

This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License
as published by the Free Software Foundation, version 2.

This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more details.
 */
package com.clustercontrol.cloud.ui.views.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;

public abstract class SingleSelectionActionEx extends AbstractViewAction {
	@Override
	public void selectionChanged(IAction action, ISelection selection) {
		if (!(selection instanceof IStructuredSelection)) {
			action.setEnabled(false);
		}
		
		IStructuredSelection ss = (IStructuredSelection)selection;
		
		if (ss.size() == 1 && canEnabled(ss)) {
			action.setEnabled(true);
		}
		else {
			action.setEnabled(false);
		}
	}
	
	protected boolean canEnabled(IStructuredSelection selection) {
		return true;
	}
}
